; V1.01
;
; To compile use:
;
; AS80 [1.31] - Assembler for 8080/8085/Z80 microprocessor.
;
; Available from:
;   - http://www.falstaff.demon.co.uk/cross.html
;   - ftp://ftp.simtel.net/pub/simtelnet/msdos/crossasm/as80_131.zip
;   - and many Simtel mirrors.
;
; as80 -i -l -n -x2 -v mz-1e14.asm




SIOAD   EQU     $F4
SIOBD   EQU     $F5
SIOAC   EQU     $F6
SIOBC   EQU     $F7



;       RxD_A   <-  RDDT (ReaDDaTa)
;       RxC_A   <-	(read data clock)
;       TxD_A   ->  #WRDT (WRiteDaTa)
;       TxC_A   <-  6.5MHz / 4 / 16 = 101562,5Hz
;       CTS_A	<-	#WRPR (WRitePRotect)
;	    RTS_A	->	#WRGA (WRiteGAte)
;       DCD_A   <-  #HDST (HeaDSeT (disk test)
;
;       RTS_B   ->	(?)
;       DCD_B   <-  #HOME ()
;       DTR_B   ->  #MTON (MoTorON)




GETL    EQU     $0003
NL      EQU     $0009
PRNT    EQU     $0012
GETKY   EQU     $001B
BRKEY   EQU     $001E
CMY0    EQU     $005B
MSGE1   EQU     $0147
DOT4DE  EQU     $02A6
?TMST   EQU     $0308
SPHEX   EQU     $03B1
SLPT    EQU     $03D5
HLHEX   EQU     $0410
_2HEX   EQU     $041F
?WRI    EQU     $0436
LLPT    EQU     $0470
?WRD    EQU     $0475
?RDI    EQU     $04D8
?RDD    EQU     $04F8
?VRFY   EQU     $0588
NLPHL   EQU     $05FA
?KEY    EQU     $08CA
?PRTS   EQU     $0920
MSGOK   EQU     $0942
PRNT3   EQU     $096C
MSGSV   EQU     $098B
MSG?2   EQU     $09A0
?BRK    EQU     $0A32
?ADCN   EQU     $0BB9
?BLNK   EQU     $0DA6
?DPCT   EQU     $0DDC

BRKCD   EQU     00
NTFECD  EQU     40
HDERCD  EQU     41
WPRTCD  EQU     46
QNTRCD  EQU     50
NFSECD  EQU     53
UNFMCD  EQU     54

ATRB    EQU     $10F0
NAME    EQU     $10F1
SIZE    EQU     $1102
DTADR   EQU     $1104
EXADR   EQU     $1106
COMNT   EQU     $1108

NAMSIZ  EQU     $11
OBJCD   EQU     $01
                                ; QD command table
QDPA    EQU     $1130           ; QD code 1
QDPB    EQU     $1131           ; QD code 2
QDPC    EQU     $1132           ; QD header startaddress
QDPE    EQU     $1134           ; QD header length
QDCPA   EQU     $113B           ; QD error flag
HDPT    EQU     $113C           ; QD new headpoint possition
HDPT0   EQU     $113D           ; QD actual headpoint possition
FNUPS   EQU     $113E
FNUPF   EQU     $1140
FNA     EQU     $1141           ; File Number A (actual file number)
FNB     EQU     $1142           ; File Number B (next file number)
MTF     EQU     $1143           ; QD motor flag
RTYF    EQU     $1144
SYNCF   EQU     $1146           ; SyncFlags
RETSP   EQU     $1147
DSPXY   EQU     $1171
DPRNT   EQU     $1194
SWRK    EQU     $119D
BUFER   EQU     $11A3
QDIRBF  EQU     $CD90



        ORG     $E800

MZ1E14:
LE800:
        NOP
        JP LE80A
        JP ST1X
QDIOS:
        JP QDIOS1

LE80A:
        LD A,$C6                ; clear screen
        CALL ?DPCT
        XOR A
        LD (DPRNT),A
        DI
        XOR A
        LD DE,$0000
        CALL ?TMST
        LD A,$01
        OUT (SIOBC),A           ; select Write Register 1
        XOR A
        OUT (SIOBC),A           ; Rx INT DISABLE
        CALL GETKY
        CP 'M'
        JR Z,MON
        CP 'Q'
        JR Z,QBT
        CALL LEB22              ; check ROM at 0xF000 (FDD)
        CALL Z,$F006
        JR QBT
;
;===============================
;
;       Quick disk boot-up
;
;===============================
;
QBT:
        CALL IOFRS              ; IO Flag ReSet
        CALL NL
        CALL QDRCK              ; QuickDisk Ready ChecK
        JR C,LE868
        LD A,$0D                ; set filename to ""
        LD (BUFER),A
        CALL HDPCL              ; HeaD Point CLear
;
;       Error return set
;
        LD A,$01
        LD (QDCPA),A
        LD HL,LE86B
        LD SP,$10EE
        EX (SP),HL
;
;
        CALL FILSCH             ; filesearch
        JP C,LEBAC
        LD A,(ATRB)
        CP OBJCD                ; is it an "OBJ" file
        JR NZ,LE871
;
;       Quick disk boot
;
        LD DE,LEB27
        RST $18
        JP DSFLNA

LE868:
        LD DE,LEB37
LE86B:
        CALL NL
        RST $18
        JR LE87D
LE871:
        LD A,$06                ; Motor off
        LD (QDPA),A
        CALL QDIOS
        LD DE,LED4C
        RST $18
LE87D:
        CALL NL

MON:
        LD DE,DISCLR            ; '**  MONITOR 9Z-503M  **'
        RST $18


ST1X:
        CALL NL
        LD A,'*'
        CALL PRNT
        LD DE,BUFER
        CALL GETL
ST2X:
        LD A,(DE)
        INC DE
        CP $0D
        JR Z,ST1X
        CP 'J'                  ; JUMP
        JR Z,GOTOX
        CP 'L'                  ; Load CMT
        JR Z,LOADX
        CP 'F'                  ; Floppy boot
        JR Z,FDCK
        CP 'B'                  ; Bell
        JP Z,SGX
        CP '#'
        JP Z,LEA6A
        CP 'P'                  ; Printer test
        JP Z,PTESTX
        CP 'M'                  ; Memory correction
        JP Z,MCORX
        CP 'S'                  ; Save CMT
        JP Z,SAVEX
        CP 'V'                  ; Verify
        JP Z,VRFYX
        CP 'D'                  ; Dump memory
        JP Z,DUMPX
        CP 'Q'                  ; Quick disk cmd.
        JR NZ,ST2X
;
;       Quick disk cmd.
;
QUICK:
        LD HL,$0000
        LD ($113A),HL
        LD A,(DE)
        CP 'L'                  ; Load QD
        JP Z,QL
        CP 'D'                  ; Directory
        JP Z,QD
ST1X1:
        JR ST1X


FDCK:
        LD A,(DE)
        CP $0D
        JR NZ,ST1X1
        CALL LEB22
        CALL Z,$F006
        JR ST1X1
?ERX:
        CP $02
        JR Z,ST1X1
        CALL NL
        LD DE,MSGE1             ; 'CHECK SUM ER.'
        RST $18
        JR ST1X1
BGETLX:
        EX (SP),HL
        POP BC
        LD DE,BUFER
        CALL GETL
        LD A,(DE)
        CP $1B
        JR Z,ST1X1
        JP (HL)

HEXIYX:
        EX (SP),IY
        POP AF
        CALL HLHEX
        JR C,ST1X1
        JP (IY)

GOTOX:
        CALL HEXIYX
        JP (HL)

               
LOADX:
        CALL ?RDI
        JR C,?ERX
        CALL NL
        LD DE,MSG?2             ; 'LOADING '
        RST $18
        LD DE,NAME
        RST $18
        XOR A
        LD (BUFER),A
        LD HL,(DTADR)
        LD A,H
        OR L
        JR NZ,LE941
        LD HL,(EXADR)
        LD A,H
        OR L
        JR NZ,LE941
        LD A,$FF
        LD (BUFER),A
        LD HL,$1200
        LD (DTADR),HL
LE941:
        CALL ?RDD
        JR C,?ERX
        LD A,(BUFER)
        CP $FF
        JR Z,LE954
        LD BC,$0100
        LD HL,(EXADR)
        JP (HL)
LE954:
        OUT ($E0),A
        LD HL,$1200
        LD DE,$0000
        LD BC,(SIZE)
        LDIR
        LD BC,$0100
        JP $0000

PTESTX:
        LD A,(DE)
        CP '&'                  ; plotter test
        JR NZ,PTST1X
PTST0X:
        INC DE
        LD A,(DE)
        CP 'L'                  ; 40 in 1 line
        JR Z,.LPTX
        CP 'S'                  ; 80 in 1 line
        JR Z,..LPTX
        CP 'C'                  ; Pen change
        JR Z,PENX
        CP 'G'                  ; Graph mode
        JR Z,PLOTX
        CP 'T'                  ; Test
        JR Z,PTRNX
;
PTST1X:
        CALL PMSGX
ST1X2:
        JP ST1X1
.LPTX:
        LD DE,LLPT              ; 01-09-09-0B-0D
        JR PTST1X
..LPTX:
        LD DE,SLPT              ; 01-09-09-09-0D
        JR PTST1X
PTRNX:
        LD A,$04                ; Test pattern
        JR LE999
PLOTX:
        LD A,$02                ; Graph mode
LE999:
        CALL LPRNTX
        JR PTST0X
PENX:
        LD A,$1D                ; 1 change code (text mode)
        JR LE999
;
;
;       1 char print to $LPT
;
;        in: ACC print data
;
;
LPRNTX:
        LD C,$00                ; RDAX test
        LD B,A                  ; print data store
        CALL RDAX
        LD A,B
        OUT ($FF),A             ; data out
        LD A,$80                ; RDP high
        OUT ($FE),A
        LD C,$01                ; RDA test
        CALL RDAX
        XOR A                   ; RDP low
        OUT ($FE),A
        RET
;
;       $LPT msg.
;       in: DE data low address
;       0D msg. end
;
PMSGX:
        PUSH DE
        PUSH BC
        PUSH AF
PMSGX1:
        LD A,(DE)               ; ACC = data
        CALL LPRNTX
        LD A,(DE)
        INC DE
        CP $0D                  ; end ?
        JR NZ,PMSGX1
        POP AF
        POP BC
        POP DE
        RET
;
;       RDA check
;
;       BRKEY in to monitor return
;       in: C RDA code
;
RDAX:
        IN A,($FE)
        AND $0D
        CP C
        RET Z
        CALL BRKEY
        JR NZ,RDAX
        LD SP,ATRB
        JR ST1X2
;
;       Memory correction
;       command 'M'
;
MCORX:
        CALL HEXIYX             ; correction address
MCORX1:
        CALL NLPHL              ; corr. adr. print
        CALL SPHEX              ; ACC ASCII display
        CALL ?PRTS              ; space print
        CALL BGETLX             ; get data & check data
        CALL HLHEX              ; HLASCII(DE)
        JR C,MCRX3
        CALL DOT4DE             ; INC DE * 4
        INC DE
        CALL _2HEX              ; data check
        JR C,MCORX1
        CP (HL)
        JR NZ,MCORX1
        INC DE
        LD A,(DE)
        CP $0D                  ; not correction
        JR Z,MCRX2
        CALL _2HEX              ; ACCHL(ASCII)
        JR C,MCORX1
        LD (HL),A               ; data correct
MCRX2:
        INC HL
        JR MCORX1
MCRX3:
        LD H,B                  ; memory address
        LD L,C
        JR MCORX1
;
;       Programm save
;
;       cmd. 'S'
;
SAVEX:
        CALL HEXIYX             ; Start address
        LD (DTADR),HL           ; data adress buffer
        LD B,H
        LD C,L
        CALL DOT4DE
        CALL HEXIYX             ; End address
        SBC HL,BC               ; byte size
        INC HL
        LD (SIZE),HL            ; byte size buffer
        CALL DOT4DE
        CALL HEXIYX             ; execute address
        LD (EXADR),HL           ; buffer
        CALL NL
        LD DE,MSGSV             ; 'FILENAME? '
        RST $18
        CALL BGETLX             ; filename input
        CALL DOT4DE
        CALL DOT4DE
        LD HL,NAME              ; name buffer
SAVX1:
        INC DE
        LD A,(DE)
        LD (HL),A               ; filename trans.
        INC HL
        CP $0D                  ; end code
        JR NZ,SAVX1
        LD A,OBJCD              ; attribute: OBJ
        LD (ATRB),A
        CALL ?WRI
?ERX1:
        JP C,?ERX
        CALL ?WRD               ; data
        JR C,?ERX1
        CALL NL
        LD DE,MSGOK             ; 'OK!'
        RST $18
LEA5B:
        JP ST1X

VRFYX:
        CALL ?VRFY
        JP C,?ERX
        LD DE,MSGOK             ; 'OK!'
        RST $18
        JR LEA5B
LEA6A:
        JP CMY0

SGX:
        LD A,(SWRK)
        RRA
        CCF
        RLA
        LD (SWRK),A
LEA76:
        JR LEA5B

DUMPX:
        CALL HEXIYX
        CALL DOT4DE
        PUSH HL
        CALL HLHEX
        POP DE
        JR C,LEAD6
LEA85:
        EX DE,HL
LEA86:
        LD B,$08
        LD C,$17
        CALL NLPHL
LEA8D:
        CALL SPHEX
        INC HL
        PUSH AF
        LD A,(DSPXY)
        ADD A,C
        LD (DSPXY),A
        POP AF
        CP $20
        JR NC,LEAA0
        LD A,$2E
LEAA0:
        CALL ?ADCN
        CALL PRNT3
        LD A,(DSPXY)
        INC C
        SUB C
        LD (DSPXY),A
        DEC C
        DEC C
        DEC C
        PUSH HL
        SBC HL,DE
        POP HL
        JR Z,LEAD3
        LD A,$F8
        LD ($E000),A
        NOP
        LD A,($E001)
        CP $FE
        JR NZ,LEAC7
        CALL ?BLNK
LEAC7:
        DJNZ LEA8D
LEAC9:
        CALL ?KEY
        OR A
        JR Z,LEAC9
        CALL ?BRK
        DB  $20
LEAD3:
        DB  $B2
      
        JR LEA76
LEAD6:
        LD HL,$00A0
        ADD HL,DE
        JR LEA85

FNINP:
        CALL NL
        LD DE,MSGSV             ; 'FILENAME? '
        RST $18
        LD DE,BUFER
        CALL GETL
        LD A,(DE)
        CP #1B
        JR NZ,LEAF3
        LD HL,ST1X
        EX (SP),HL
        RET

LEAF3:
        LD B,$00
        LD DE,$11AD
        LD HL,BUFER
        LD A,(DE)
        CP $0D
        JR Z,LEB20
LEB00:
        CP $20
        JR NZ,LEB08
        INC DE
        LD A,(DE)
        JR LEB00
LEB08:
        CP $22
        JR Z,LEB14
LEB0C:
        LD (HL),A
        INC HL
        INC B
        LD A,$11
        CP B
        JR Z,FNINP
LEB14:
        INC DE
        LD A,(DE)
        CP $22
        JR Z,LEB1E
        CP $0D
        JR NZ,LEB0C
LEB1E:
        LD A,$0d
LEB20:
        LD (HL),A
        RET

LEB22:
        LD A,($F000)
        OR A
        RET
               

LEB27:  DB      'IPL IS LOADING ',$0D
LEB37:  DB      'MAKE READY QD',$0D
DISCLR: DB      '**  MONITOR 9Z-503M  **',$0D

;
;====================================
;
;       QUICK DISK LOAD COMMAND
;
;====================================
;
QL:
        CALL IOFRS
        CALL QDRCK              ; Ready check
        JR C,LEBAC
        CALL FNINP              ; Input filename
        CALL HDPCL              ; Head point clear
;
;       Disp 'Loading...'
;
        LD DE,MSG?2             ; 'LOADING '
        RST $18
;
;       File search
;
FILESH:
        CALL FILSCH
        JR C,LEBAC
;
;       Atribute check
;
        LD A,(ATRB)
        CP OBJCD
        JR NZ,FILESH
;
;
;
DSFLNA:
        LD DE,NAME
        RST $18

        LD HL,(EXADR)
        LD A,H
        OR L
        JR NZ,LEB8B
        LD HL,(COMNT)
        LD A,H
        OR L
LEB8B:
        JR NZ,LPARA0
        LD A,$FF
        LD ($113A),A



;
;       Iocs parameter set
;
        LD HL,$1200
        JR LPARA1
LPARA0:
        LD HL,(EXADR)
LPARA1:
        LD (QDPC),HL            ; Data adrs set
        LD HL,(DTADR)
        LD (QDPE),HL
        LD HL,$0103             ; Read data block cmd.
        LD (QDPA),HL            ; QDPA = 3 (read from headpoint)
                                ; QDPB = 1 (data should be read)
;
;       Read data block
;
        CALL QDIOS              ; QD iocs
LEBAC:
        JP C,QER04
        LD A,($113A)
        CP $FF
        JR Z,LEBBD
;
;       Exec load file
;
        LD BC,$0300
        LD HL,(COMNT)
        JP (HL)

LEBBD:
        OUT ($E0),A
        LD HL,$1200
        LD DE,$0000
        LD BC,(DTADR)
        LDIR
        LD BC,$0300
        JP $0000

;
;       Iocs flag reset
;
IOFRS:
        XOR A
        LD (MTF),A              ; Motor Flag = 0 (OFF)
        LD (FNUPS),A            ; File number flag = 0
        LD (FNUPF),A            ; File number up flag = 0
        RET

;
;
;       File search sub.
;
;
FILSCH:
;
;       Iocs parameter set
;
        LD HL,$0003             ; read from headpoint
        LD (QDPA),HL            ; QDPA = 3 (read from head point)
                                ; QDPB = 0 (header should be read)
        LD HL,ATRB              ; Head adrs
        LD (QDPC),HL
        LD HL,$0040             ; Read size
        LD (QDPE),HL

;
;       Read information block
;
QLINF:
        CALL QDIOS
        RET C
;
;       File name check
;
        LD A,(BUFER)
        CP $0D
        RET Z
        LD HL,BUFER
        LD DE,NAME
        LD B,NAMSIZ
LDFNCK:
        LD A,(DE)
        CP (HL)
        JR NZ,QLINF
        CP $0D
        RET Z
        INC DE
        INC HL
        DJNZ LDFNCK
        RET
;
;       Quick disk ready check
;
QDRCK:
        XOR A
        LD (QDPB),A     ; QDPB = 0 -> only Ready check
        INC A
        LD (QDPA),A     ; QDPA = 1
        CALL QDIOS
        RET
;
;======================================
;
;       Quick disk directory command
;
;======================================
;
QD:
        CALL IOFRS
        CALL QDRCK
        JR C,QER04
        CALL HDPCL
        LD B,$00
;
;       Disp 'Directory of QD:'
;
        LD DE,DIRMSG
        RST $18
;
;       Iocs parameter set
;
        LD HL,QDIRBF
DIRIOP:
        LD (QDPC),HL
        LD HL,$0003
        LD (QDPA),HL            ; QDPA = 3 (read from headpoint)
                                ; QDPB = 0 (header should be read)
        LD HL,$0040
        LD (QDPE),HL            ; QDPE = 64 (header length)
;
;       Read information block
;
        PUSH BC
        CALL QDIOS
        POP BC
        JR C,DIREFC
        INC B
;
;       Buffer adrs increment
;
        LD HL,(QDPC)
        LD DE,PRNT
        ADD HL,DE
        JR DIRIOP
;
;       End file check
;
DIREFC:
        CP NTFECD
        JR Z,DIRMTF
        SCF
QER04:
        JR C,QERTRT
;
;       Motor off
;
DIRMTF:
        LD A,$06                ; Motor off command
        LD (QDPA),A
        PUSH BC
        CALL QDIOS
        POP BC
;
;       No file check
;
        XOR A
        CP B
        JR NC,QDOKM
;
;       Directory disp
;
        CALL NL
        LD HL,QDIRBF
;
;       Disp atribute
;
DSPATR:
        LD A,(HL)
        LD DE,MSGQ01
        DEC A
        JR Z,LECA4
        LD DE,MSGQ02
        DEC A
        JR Z,LECA4
        LD DE,MSGQ03
        DEC A
        JR Z,LECA4
        LD DE,MSGQ04
        DEC A
        JR Z,LECA4
        LD DE,MSGQ05
        DEC A
        JR Z,LECA4
        DEC A
        JR Z,LECA1
        LD DE,MSGQ07
        DEC A
        JR Z,LECA4
        DEC A
        JR Z,LECA1
        DEC A
        JR Z,LECA1
        LD DE,MSGQ10
        DEC A
        JR Z,LECA4
        LD DE,MSGQ11
        DEC A
        JR Z,LECA4
LECA1:
        LD DE,MSGQ??
LECA4:
        RST $18
;
;       Disp file name
;
LECA5:
        LD A,'"'
        CALL PRNT
        INC HL
        PUSH HL
        POP DE
        RST $18
        LD A,'"'
        CALL PRNT
        CALL NL
;
;       Counter decrement
;
LECB6:
        LD DE,$0011
        ADD HL,DE
LECBA:
        CALL ?KEY
        OR A
        JR Z,LECBA
        CALL ?BRK
        JP Z,ST1X
        DJNZ DSPATR

QDOKM:
        CALL NL
        LD DE,MSGQOK
        RST $18
        JP ST1X

;
;======================================
;
;       Error treatment
;
;=====================================
;
QERTRT:
        LD DE,MGNFE             ; 'Not Found err'
        CP NTFECD               ; Not found err
        JR Z,QERMF
        LD DE,MGNRE             ; 'Not ready'
        CP QNTRCD               ; Not ready
        JR Z,QERMF
        LD DE,MGUFE             ; 'Unformat'
        CP UNFMCD               ; Unformat err
        JR Z,QERMF
        LD DE,MSGTRM
        CP BRKCD                ; Break
        JR Z,QERMF
        LD DE,MGHDE             ; 'Hard error'
;
;       Motor off
;
QERMF:
        LD A,$06                ; Motor off cmd.
        LD (QDPA),A
        CALL QDIOS
        CALL HDPCL
;
LECFC:
        LD A,(QDCPA)
        RRA
        RET C                   ; Boot err
        CALL NL
        RST $18
        JP ST1X
;
;       Header point clear
;
HDPCL:
        LD A,$05                ; Head point clear cmd.
        LD (QDPA),A
        CALL QDIOS
        RET
;
;======================================
;
;       Message table
;
;======================================
;
MSGQOK: DB      'OK!'
MSGTRM: DB      $0D
MGNFE:  DB      'QD:FILE NOT FOUND',$0D
MGHDE:  DB      'QD:HARD ERR',$0D
MGNRE:  DB      'QD:NOT READY',$0D
MGUFE:  DB      'QD:UNFORMAT',$0D
LED4C:   DB      'QD:FILE MODE ERR',$0D
DIRMSG: DB      'DIRECTORY OF QD:',$0D
MSGQ01: DB      '    OBJ   ',$0D
MSGQ02: DB      '    BTX   ',$0D
MSGQ03: DB      '    BSD   ',$0D
MSGQ04: DB      '    BRD   ',$0D
MSGQ05: DB      '    RB    ',$0D
MSGQ07: DB      '    LIB   ',$0D
MSGQ10: DB      '    SYS   ',$0D
MSGQ11: DB      '    GR    ',$0D
MSGQ??: DB      '    ???   ',$0D


QDIOS1:
        LD A,$05                ; Retry 4
        LD (RTYF),A
;
RTY:
        DI
        CALL QMEIN
        EI
        RET NC
        PUSH AF
        CP $28
        JR Z,RTY4
        CALL MTOF
        POP AF
        PUSH AF
        CP $29
        JR NZ,RTY4
        LD HL,RTYF
        DEC (HL)
        JR Z,LEDF3
        POP AF
        JR RTY
LEDF3:
        CALL QDHPC
RTY4:
        POP AF
        RET

QMEIN:
        LD (RETSP),SP
        LD A,(QDPA)
        DEC A                   ; ready check           (1)
        JR Z,QDRC
        DEC A                   ; format                (2)
                                ; not implemented
        DEC A                   ; read from headpoint   (3)
        JR Z,QDRD
        DEC A                   ; save from headpoint   (4)
                                ; not implemented
        DEC A                   ; headpoint clear       (5)
        JR Z,QDHPC
        JP MTOF                 ; else motor off
;
;======================================
;
;       Head Point Clear
;
;======================================
;
QDHPC:
        PUSH AF
        XOR A
        LD (HDPT),A
        POP AF
        RET
;
;=================================
;
;       Ready Check
;
;=================================
;
QDRC:
        LD A,(QDPB)             ; QDPB = 0 -> only Ready check
        JP QREDY
;
;=================================
;
;       Read
;
;=================================
;
QDRD:
        LD A,(MTF)              ; A = Motor Flag
        OR A                    ; test Motor Flag
        CALL Z,MTON             ; if Motor Flag = 0 then Motor On and go to home position
        CALL HPS                ; head point search
        RET C
        CALL BRKC               ; check break key
;
        CALL RDATANRCK          ; read low-byte blocksize
        LD C,A
        CALL RDATANRCK          ; read high-byte blocksize
        LD B,A
        LD HL,(QDPE)
        SBC HL,BC               ;
        JP C,IOE41
        LD HL,(QDPC)
;
; Block Data Read
;
BDR:
        CALL RDATANRCK          ; read data
        LD (HL),A               ; save it
        INC HL                  ; inc address
        DEC BC                  ; dec counter
        LD A,B
        OR C
        JR NZ,BDR               ; counter not zero than read again
        CALL RDCRC              ; read checksum (3 bytes)
        LD A,(QDPB)
        BIT 0,A
        JP NZ,MTOF
        RET
;
; Head Point Search
;
HPS:
        LD HL,FNB               ; HL = next file number
        DEC (HL)
        JR Z,HPNFE              ; Not found
        CALL SYNCL2             ; read 2 bytes last is in A
        LD C,A                  ; BLocKFLaG => C reg
        LD A,(HDPT)             ; A = destination head point position
        LD HL,HDPT0             ; HL = address of the actual head point position
        CP (HL)                 ; Search ok ?
        JR NZ,HPS1              ; no, than make dummy block read
        INC A                   ; HDPT count up
        LD (HDPT),A
        LD (HL),A               ; HDPT0 count up
        LD A,(QDPB)             ; A = filetype to load
        XOR C                   ; xor with BLocKFLaG which
        RRA
        RET NC                  ; same, than ret else ...
;
; Dummy read
;
DMR:
        CALL RDATANRCK          ; read size low byte
        LD C,A
        CALL RDATANRCK          ; read size high byte
        LD B,A
;
DMR1:                           ; read size bytes
        CALL RDATANRCK
        DEC BC
        LD A,B
        OR C
        JR NZ,DMR1
        CALL RDCRC              ; read checksum (3 bytes)
        JR HPS                  ; next
;
HPS1:
        INC (HL)                ; increment actual head point position
        JR DMR
;
HPNFE:
        LD A,NTFECD             ; Not Found
        SCF
        RET



;
; Ready & Write protect
;       ACC = 0 : Ready check
;       ACC = 1 : & Write Protect
;
QREDY:
        LD B,A                  ; save command
        LD A,$02
        OUT (SIOBC),A           ; select register 2 (IV)
        LD A,$81
        OUT (SIOBC),A           ; write 81h in register 2
        LD A,$02
        OUT (SIOBC),A           ; select register 2 (IV)
        IN A,(SIOBC)            ; read back register 2
        AND $81
        CP $81
        JP NZ,IOE50             ; Not ready
        LD A,$10
        OUT (SIOAC),A           ; NULL CODE, RESET EXT/STATUS INT, REGISTER 0
        IN A,(SIOAC)
        LD C,A                  ; save Read Register 0
        AND $08                 ; test DCD (HeadSet)
        JP Z,IOE50              ; Not ready
        LD A,B                  ; restore command
        OR A                    ; if command = 0 then
        RET Z                   ; return
        LD A,C                  ; else restore Read Register 0
        AND $20                 ; test CTS (WriteProtect)
        RET NZ                  ; if CTS then not protected, return
        JP IOE46                ; else Write protect

;
;
; MTON -- QD MOTOR ON
;         READ FILE NUMBER
;         READ & CHECK CRC,FLAG
;
MTON:
        LD HL,SIOLD		        ; SIO Load Data
        LD B,$0B
        CALL LSINT              ; load SIO init and motor on and go to home position

        CALL SYNCL1             ; search for sync and read first 2 bytes, last is in A
        LD (FNA),A              ; save actual file no in File Number A
        INC A
        LD (FNB),A              ; save next file no in File Number B
        CALL RDCRC              ; read checksum (3 bytes)
FNEND:
        LD HL,SYNCF
        SET 3,(HL)              ; set bit3 of SyncFlags
        XOR A                   ; A = 0
        LD (HDPT0),A            ; actual head point position = 0
        RET
;
;       sio initial
;
LSINT:
        LD C,SIOAC
        OTIR
        LD A,$05		; 00000101
        LD (MTF),A              ; MoTor Flag = 5
        OUT (SIOBC),A           ; ch B select register 5
        LD A,$80		; 10000000
        OUT (SIOBC),A           ; set DTR_B (Motor On), clear RTS_B

LREDY:				; check for ready and if so, than goto home position
        LD A,$10		; 00010000
        OUT (SIOAC),A           ; reset ext/status interrupts, set register 0
        IN A,(SIOAC)            ; read register 0
        AND $08                 ; test DCD_A (disk inside ?)
        JP Z,IOE50              ; Not ready
        CALL BRKC               ; BReak Key Check
        LD A,$10		; 00010000
        OUT (SIOBC),A           ; reset ext/status interrupts, set register 0
        IN A,(SIOBC)            ; read register 0
        AND $08                 ; test DCD_B (Home)
        JR Z,LREDY
        LD BC,$00E9             ; wait 160ms
        JP TIMW

;
; Motor off
;
QDOFF:                          ; basic call
MTOF:
        PUSH AF
        LD A,$05
        OUT (SIOAC),A           ; select Write Register 5
        LD A,$60                ; 01100000
        OUT (SIOAC),A           ; DTR OFF (Motor Off), Tx DISABLE, RTS OFF (WRGA)
        LD A,$05
        OUT (SIOBC),A           ; select Write Register 5
        XOR A                   ; 00000000
        LD (MTF),A              ; Motor Flag = 0
        OUT (SIOBC),A           ; DTR OFF (Motor Off), clear  RTS_B
        POP AF
        RET

;
; SYNCL1 -- LOAD F.N SYNC ONLY
;                (SEND BREAK 110ms)
; SYNCL2 -- LOAD FIRST FILE SYNC
;                (SEND BREAK 110ms)
;
SYNCL2:
        LD A,$58                ; 01011000
                                ; RESET Rx CRC CHECKER, CHANNEL RESET, REGISTER 0
        LD B,$0B                ; 11 values to load
        LD HL,SIOLD
        CALL SYNCA
        LD HL,SYNCF
        BIT 3,(HL)              ; test bit3 of SyncFlags
        LD BC,$0003             ; WAIT 2ms
        JR Z,TMLPL
        RES 3,(HL)              ; reset bit3 of SyncFlags
SYNCL1:
        ld bc,$00a0             ; WAIT 110ms
;
TMLPL:			; the motor is switched on
				; and a hunt phase is initiated,
				; that means the incoming datastream
				; is inspected for the programmed 
				; sync characters
        CALL TIMW
        LD A,$05
        OUT (SIOBC),A           ; select Write Register 5
        LD A,$82                ; 10000010
        OUT (SIOBC),A           ; DTR ON (Motor On), RTS ON ()
        LD A,$03
        OUT (SIOAC),A           ; select Write Register 3
        LD A,$D3                ; 11010011
        OUT (SIOAC),A           ; RX 8 BIT, ENTER HUNT PHASE, SYNC, Rx ENABLE
        LD BC,$2CC0             ; 220ms timeout
;
SYNCW0:				; now the datastream is inspected
				    ; also a timeout is checked
        LD A,$10
        OUT (SIOAC),A           ; RESET EXT/STATUS INT, select Register 0
        IN A,(SIOAC)
        AND $10                 ; test SYNC/HUNT
        JR Z,SYNCW1		        ; first 2 syncbytes found
        DEC BC
        LD A,B
        OR C
        JR NZ,SYNCW0
        JP IOE54                ; unformatted
;
SYNCW1:				; now we should ignore further sync characters
        LD A,$03
        OUT (SIOAC),A           ; select Write Register 3
        LD A,$C3                ; 11000011
        OUT (SIOAC),A           ; Rx 8 BIT, SYNC CHAR LOAD INHIBIT, Rx ENABLE
        LD B,$9F                ; timeout
;
SYNCW2:
				; loop for find the end of syncbytes:
				; rx available is only set if the first
				; byte is found which is not a syncbyte
        LD A,$10
        OUT (SIOAC),A           ; NULL CODE, RESET EXT/STATUS INT, REGISTER 0
        IN A,(SIOAC)
        AND $01                 ; test Rx CHARACTER AVAILABLE
        JR NZ,SYNCW3
        DEC B
        JR NZ,SYNCW2
SYNCW01:
        JP IOE54                ; unformated
;
SYNCW3:				; now the datastream is in sync and the
				    ; first real data is ready to read
        LD A,$03
        OUT (SIOAC),A           ; select Write Register 3
        LD A,$C9                ; 11001001
        OUT (SIOAC),A           ; Rx 8 BIT, Rx CRC ENABLE, Rx ENABLE
        CALL RDATANRCK
        JP RDATANRCK

;
;
;
SYNCA:
        LD C,SIOAC
        OUT (C),A
        LD A,$05
        OUT (SIOBC),A           ; select Write Register 5
        LD A,$80
        OUT (SIOBC),A           ; set DTR_B (Motor On), clear RTS_B
        OTIR
        RET

;
;       RDCRC -- READ CRC & CHECK
;
RDCRC:
        LD B,$03                ; 3 retries
RDCR1:
        CALL RDATANRCK          ; read 3 bytes
        DJNZ RDCR1
RDCR2:                          ; read REGISTER 0
        IN A,(SIOAC)
        RRCA                    ; test Rx CHARACTER AVAILABLE
        JR NC,RDCR2             ; Rx Available
        LD A,$01                
        OUT (SIOAC),A           ; select REGISTER 1
        IN A,(SIOAC)            ; read REGISTER 1
        AND $40                 ; test CRC ERROR
        JR NZ,IOE41             ; Hard err
        OR A
        RET

RDATANRCK:
NRCK:
        LD A,$10
        OUT (SIOAC),A           ; reset ext/status interrupts, set register 0
        IN A,(SIOAC)            ; read register 0
        AND $08                 ; test DCD (HeadSet)
        JP Z,IOE50              ; Not Ready
;
;       Read data (1 chr)
;
RDATA:
        IN A,(SIOAC)            ; read REGISTER 0
        RLCA
        JR C,IOE41              ; test BREAK/ABORT (Hard Err)
        RRCA
        RRCA
        JR NC,NRCK              ; test Rx AVAILABLE
        IN A,(SIOAD)            ; read data
        OR A
        RET
               
;
;       i/o err
;
IOE41:
        LD A,HDERCD             ; Hard err
        DB $21
IOE46:
        LD A,WPRTCD             ; Write protect
        DB $21
IOE50:
        LD A,QNTRCD             ; Not ready
        DB $21
IOE53:
        LD A,NFSECD             ; No file space
        DB $21
IOE54:
        LD A,UNFMCD             ; Unformat
        LD SP,(RETSP)
        SCF
        RET
               

;
;       wait timer
;
;
;       BC = 0001H =   0.7ms (  0.704ms)
;            0003H =   2.0ms (  2.107ms)
;            001DH =  20.0ms ( 19.938ms)
;            00A0H = 110.0ms (110.050ms)
;            00E9H = 160.0ms (160.140ms)
;            0140H = 220.0ms (219.940ms)
;
;
TIMW:
        PUSH AF
TIMW1:
        LD A,$86
TIMW2:
        DEC A
        JR NZ,TIMW2
        DEC BC
        LD A,B
        OR C
        JR NZ,TIMW1
        POP AF
        RET


;
;
;
; SIO CH A COMMAND CHAIN
;
; SIOLD -- LOAD INIT. DATA
;
;
;
; BiSync mode, uses 16h and 16h as sync characters
; the SIO works also in polling mode, no interrupt is generated
;
SIOLD:
        DB      $58             ; RESET Rx CRC CHECKER, CHANNEL RESET
        DB      $04             ; select Write Register 4
        DB      $10             ; X1 CLOCK mode, 16 bit sync char, sync mode, no parity
        DB      $05             ; select Write Register 5
        DB      $04             ; CRC-16
        DB      $03             ; select Write Register 3
        DB      $D0             ; RX 8 BITS, AUTO ENABLES, ENTER HUNT PHASE
        DB      $06             ; select Write Register 6
        DB      $16             ; set SYNC CHR(1)
        DB      $07             ; select Write Register 7
        DB      $16             ; set SYNC CHR(2)


;
;
; BREAK CHECK
;
BRKC:
        LD A,$E8
        LD ($E000),A
        NOP
        LD A,($E001)
        AND $81
        RET NZ
        LD SP,(RETSP)
        SCF
        RET
               
        ld l,#41


; the following is only to get the original length of 4096 bytes

        ORG $F7FF
        DB      $FF
